package com.bonus.material.task.mapper;

import java.util.Date;
import java.util.List;

import com.bonus.common.biz.domain.lease.LeaseApplyInfo;
import com.bonus.common.biz.domain.lease.LeaseOutDetails;
import com.bonus.material.back.domain.BackApplyInfo;
import com.bonus.material.basic.domain.BmUnit;
import com.bonus.material.repair.domain.RepairApplyDetails;
import com.bonus.material.settlement.domain.SltAgreementInfo;
import com.bonus.material.task.domain.TmTask;
import org.apache.ibatis.annotations.Param;

/**
 * 任务Mapper接口
 * 
 * @author xsheng
 * @date 2024-10-16
 */
public interface TmTaskMapper {
    /**
     * 查询任务
     * 
     * @param taskId 任务主键
     * @return 任务
     */
    TmTask selectTmTaskByTaskId(Long taskId);

    /**
     * 批量查询任务
     * 
     * @param taskIds 任务主键列表
     * @return 任务列表
     */
    List<TmTask> selectTmTaskByTaskIdsBatch(List<Long> taskIds);

    /**
     * 查询当年当月最大任务序号，用于生成任务编号 by 分类型查询
     * @param year 年
     * @param month 月
     * @param taskType 任务类型（字典表中获取，例如新购是:16）
     */
    int getMonthMaxOrderByDate(@Param("year") String year, @Param("month") String month, @Param("taskType") Integer taskType);

    /**
     * 查询任务列表
     * 
     * @param tmTask 任务
     * @return 任务集合
     */
    List<TmTask> selectTmTaskList(TmTask tmTask);

    /**
     * 新增任务
     * 
     * @param tmTask 任务
     * @return 结果
     */
    int insertTmTask(TmTask tmTask);

    /**
     * 修改任务
     * 
     * @param tmTask 任务
     * @return 结果
     */
    int updateTmTask(TmTask tmTask);

    /**
     * 根据任务id更新任务状态
     * @param taskId 任务id  必传
     * @param newStatus 新状态
     */
    int updateTaskStatus(@Param("taskId") String taskId, @Param("newStatus") int newStatus);

    /**
     * 删除任务
     * 
     * @param taskId 任务主键
     * @return 结果
     */
    int deleteTmTaskByTaskId(Long taskId);

    /**
     * 批量删除任务
     * 
     * @param taskIds 需要删除的数据主键集合
     * @return 结果
     */
    int deleteTmTaskByTaskIds(Long[] taskIds);

    int deleteTmTaskByPurchaseIds(Long[] ids);

    /**
     * 获取任务编号
     *
     * @param nowDate
     * @param taskType
     * @return
     */
    String selectTaskNumByMonths(Date nowDate, Integer taskType);

    List<TmTask> getTaskList(@Param("bean") SltAgreementInfo bean, @Param("taskType")Integer taskType);

    List<TmTask> getTaskIdList(SltAgreementInfo bean);

    /**
     * 根据协议id查询申请时间
     * @param agreementId
     * @return
     */
    TmTask selectTaskById(@Param("agreementId") Long agreementId, @Param("settlementType") Integer settlementType);

    /**
     * 根据协议id查询申请时间
     * @param agreementId
     * @return
     */
    TmTask selectTaskByIdByCl(Long agreementId);

    /**
     * 根据协议id查询单位
     * @param record
     * @return
     */
    BmUnit selectBmUnitById(LeaseOutDetails record);

    /**
     * 查询材料站领料数据
     * @param parseLong
     * @return
     */
    TmTask selectTmTaskByPreTaskId(Long parseLong);

    /**
     * 查询单位信息
     * @param backApplyInfo
     * @return
     */
    BmUnit selectBmUnitInfo(BackApplyInfo backApplyInfo);

    /**
     * 根据任务编号查询任务信息
     * @param code
     * @return
     */
    List<LeaseApplyInfo> selectLeaseApplyInfoByTaskNo(String code);

    /**
     * 批量删除任务
     * @param taskId
     * @return
     */
    int deleteTaskByIds(@Param("taskId") Long taskId);

    /**
     * 批量删除协议id
     * @param taskId
     * @return
     */
    int deleteAgreementId(@Param("taskId") Long taskId);

    /**
     * 根据任务id查询任务状态
     * @param taskId
     * @return
     */
    TmTask selectStatusByTaskId(Long taskId);

    /**
     * 根据任务编号查询任务信息
     * @param code
     * @return
     */
    TmTask selectTaskByCode(String code);

    /**
     * 根据任务编号查询任务信息
     * @param backApplyInfo
     * @return
     */
    List<RepairApplyDetails> selectBackApplyInfoById(BackApplyInfo backApplyInfo);

    List<TmTask> getTaskIdByAgreementId(SltAgreementInfo info);
}
